﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.3
@EndOfDesignText@
Private Sub Class_Globals
	Private const dbName As String = "trend_db.sqlite"
	Private const dbTable As String = "trend_table"
	Private mSQL As SQL
	Private mInitialized As Boolean
	Private const SubIntervals_qty As Int = 10   'the source period is divided into this number parts [ i] (iterable) to compare them
	Private OverallAVG As Float    'average Y-value of the whole period
	Private DeltaYPercent As Int = 0.5  'allowed Y-range
End Sub

'Initializes the object.
Public Sub Initialize
	File.Delete(Folder, dbName)	'deleted old database for clean test
	If mSQL.IsInitialized = False Then
		mSQL.InitializeSQLite(Folder, dbName, True)
	End If
	
	Dim ft As Map
	ft.Initialize
	ft.Put("id", DBUtils.DB_INTEGER)
	ft.Put("x", DBUtils.DB_TEXT)
	ft.Put("y", DBUtils.DB_REAL)
	DBUtils.CreateTable(mSQL, dbTable, ft, "id")
	mInitialized = True
End Sub

'Set the data set period: map key = X abscissa, map value = Y ordinate value
'Example: Dim SourceMap As Map = CreateMap("Temperature 10:00":10, "Temperature 10:10":13, "Temperature 10:20":16, "Temperature 10:30":19, "Temperature 14:00":30)
Public Sub DataMapToTrend(SourceMap As Map)
	DBUtils.ClearTable(mSQL, dbName)
	Dim L As List:L.Initialize
	For i = 0 To SourceMap.Size - 1
		Dim ft As Map
		ft.Initialize
		ft.Put("x", SourceMap.GetKeyAt(i))
		ft.Put("y", SourceMap.GetValueAt(i))
		L.Add(ft)
	Next	
	DBUtils.InsertMaps(mSQL, dbTable, L)
	OverallAVG = DBUtils.GetStringFromSQL(mSQL, "SELECT AVG(y) FROM " & dbTable)
End Sub

Public Sub isRising As Boolean
	
End Sub

Private Sub Folder As String
	Dim res As String = File.DirApp
	Return res
End Sub

Public Sub IsInitialized As Boolean
	Return mInitialized
End Sub


